//MODIFIED TO HAVE HEALTHPOINTS 
class hero_2 {
  //we set up a protocol: 
  //0:stand, 1-7:walk, 9:punch
  String current_pose;     //remember what animation is playing
  int facing;              //which way does the hero face (1=right, -1=left);
  int playhead;            //image currently showing
  float x, y, xspeed;        //hero's x, y position
  int healthpoint;
  //set up a timer to control the speed of walking animation
  int ct, st, tt;
  boolean death;
  PImage deathImg;
  int dimension;
  ArrayList simple;

  //variables to set up animation
  PImage[] sprites;        //simple image array to store all the images
  int totalImage;          
  int walk_end, walk_start;
  int punch_st, punch_ed;
  int punch;
  String pre;

  void init(String prefix) {

    totalImage=8;
    walk_start=1;
    walk_end=5;
    punch_st = 7;
    punch_ed = 7;
    pre=prefix;
    sprites=new PImage[totalImage];  //declare the size of PImage array

    for (int i=0;i<totalImage;i++) { //load images in
      sprites[i]=loadImage(pre+i+".png");
    }
    deathImg=loadImage(pre+"0.png");
    dimension = (deathImg.width*deathImg.height);
    simple=new ArrayList();
    for (int i=0;i<dimension;i++) {
      simple.add(i);
    }
    println(dimension);
    //initiate values: 
    x=width/2;
    y=505;
    healthpoint=100;

    current_pose="stand";
    playhead=0;
    death=false;
    punch = 7;

    facing=1;
    xspeed=3;

    ct=0;
    st=0;
    tt=150;
  }

  void update() {
    if (healthpoint<0) {
      death=true;
      healthpoint=0;
      //      sfx2.play(0);
    }
    if (!death) {
      if (current_pose.equals("stand")) {
        punch = punch_st;
        pushMatrix();
        translate(x, y);
        scale(facing, 1);
        image(sprites[0], -sprites[0].width/2, -sprites[0].height+10);
        popMatrix();
      }

      if (current_pose.equals("walk")) {
        punch = punch_st;
        x+=xspeed*facing;       //move hero in the direction he/she is facing

          ct=millis();            //update timer
        if (ct-st>tt) {         //if timer is up, advance playhead to the next image
          playhead+=1;
          if (playhead>walk_end) { //if it exceeds the last image, set playhead back
            playhead=walk_start;   //to the first image of this pose.
          }
          st=millis();
        }

        pushMatrix();
        translate(x, y);
        scale(facing, 1);
        image(sprites[playhead], -sprites[playhead].width/2, -sprites[playhead].height+10);
        popMatrix();
      }
      if (current_pose.equals("punch")) {
        ct = millis();
        if (ct-st > tt) {
          punch+=1;
          if (punch>punch_ed) {
            punch=punch_ed;
          }
          st = millis();
        }
        pushMatrix();
        translate(x, y);
        scale(facing, 1);
        image(sprites[punch], -sprites[punch].width/2, -sprites[punch].height+10);
        popMatrix();
      }
    }
//    else {
//      deathImg.loadPixels();
//      println(simple.size());
//      if (simple.size()>85) {
//        for (int i=0; i<85; i++) {
//          int p=(int)(random(simple.size()));
//          int m=int((simple.get(p))+"");
//          deathImg.pixels[m]=color(0, 0, 0, 0);
//          simple.remove(p);
//        }
//        deathImg.updatePixels();
//        pushMatrix();
//        translate(x, y);
//        scale(facing, 1);
//        image(deathImg, -deathImg.width/2, -deathImg.height+10);
//        popMatrix();
//      }
      else {
        reset();
      }
//    }
  }
  void reset() {
    deathImg=loadImage(pre+"0.png");
    simple=new ArrayList();
    for (int i=0;i<dimension;i++) {
      simple.add(i);
    }
    x=width/2;
    death=false;
    //    score=0;
    //    enemies=new ArrayList();
    healthpoint=100;
  }
}

